#!/bin/sh

BD=$(date +%Y%m%d)
PKGS="debian-keyring,debian-archive-keyring"
TARG="./debian-jessie-armhf_aiotg3"
ABSP=$(echo  $TARG | sed "s;./;${PWD}/;")
MIRROR="http://ftp.jp.debian.org/debian/"
RES="./aiotg3_resources"

if [ ! -e /usr/bin/qemu-arm-static ] ;then
    echo "qemu-arm-static is not installed yet."
    exit 1
fi

if [ $(whoami) != "root" ] ;then
    echo "ERROR: Please run script with sudo or root!"
    exit 1
fi

if [ -e $TARG ] ;then
    while : ;do
	echo -n $TARG is already exist. dywt remove it? [yes/NO]:
	read ans
	case $ans in
	    "yes"|"YES"|"y"|"Y")
		rm -rf $TARG
		break;;
	    ""|"no"|"NO"|"n"|"N")
		exit 1;;
	esac
    done
fi

debootstrap --arch=armhf --variant=minbase --include=$PKGS --foreign jessie $ABSP $MIRROR

#Copy emulator
cp /usr/bin/qemu-arm-static $ABSP/usr/bin

#Copy resources and fixup
cp -r $RES/* $ABSP
chroot $ABSP /bin/sh -c "\
/debootstrap/debootstrap --second-stage; \
mount -t proc proc /proc
mount -t sysfs sysfs /sys
/resources/fixup; \
apt-get clean; \
LANG=C COLUMNS=150 dpkg -l > /resources/installed_pkgs.list
umount /proc
umount /sys
"

#Remove emulator
rm $ABSP/usr/bin/qemu-arm-static

#Remove resources
cp $ABSP/resources/installed_pkgs.list ./installed_pkgs_$BD.list
rm -rf $ABSP/resources

#Archive userland
(cd $ABSP; tar zcf ../$(basename $ABSP)_$BD.tar.gz *)

#Remove working dir
rm -rf $ABSP
